function WeaponFactoryTweakData:SetupForbid( mod_one, mod_two ) 
	if self.parts[mod_one] and self.parts[mod_two] then
		if not self.parts[mod_one].forbids then
			self.parts[mod_one].forbids = {}
		end
		table.insert(self.parts[mod_one].forbids, mod_two)
	end

	if self.parts[mod_two] and self.parts[mod_one] then
		if not self.parts[mod_two].forbids then
			self.parts[mod_two].forbids = {}
		end
		table.insert(self.parts[mod_two].forbids, mod_one)
	end
end

function WeaponFactoryTweakData:CheckOverride( mod_type, mod_wpn ) 
	if mod_type == "wpn" then
		if self[mod_wpn] then
			self[mod_wpn].override = self[mod_wpn].override or {}
		end
	end
end

Hooks:PostHook(WeaponFactoryTweakData, "init", "MasterkeyModInit", function(self)
	self.parts.wpn_fps_ubs_spas12.adds = {
	"wpn_fps_ubs_spas12_body",
	"wpn_fps_ubs_spas12_barrel",
	"wpn_fps_ubs_spas12_grip",
	"wpn_fps_ubs_spas12_rail"
	}
	self.parts.wpn_fps_ubs_six12.adds = {
	"wpn_fps_ubs_six12_barrel",
	"wpn_fps_ubs_six12_shells",
	"wpn_fps_ubs_six12_rail"
	}
	
	local ubs_list = {
		"wpn_fps_ubs_spas12",
		"wpn_fps_ubs_six12"
	}
	
	for i, underbarrel_ids in ipairs(ubs_list) do
	
		self:SetupForbid( "wpn_fps_ass_m14_body_dmr", underbarrel_ids )
		
		self:SetupForbid( "wpn_fps_m4_uupg_fg_lr300", underbarrel_ids )
		self:SetupForbid( "wpn_fps_upg_fg_jp", underbarrel_ids )
		self:SetupForbid( "wpn_fps_upg_fg_smr", underbarrel_ids )
		self:SetupForbid( "wpn_fps_upg_ass_m4_fg_moe", underbarrel_ids )
		self:SetupForbid( "wpn_fps_upg_ass_m16_fg_stag", underbarrel_ids )
		self:SetupForbid( "wpn_fps_m16_fg_vietnam", underbarrel_ids )
		
		self:SetupForbid( "wpn_upg_ak_fg_standard", underbarrel_ids )
		self:SetupForbid( "wpn_upg_ak_fg_combo2", underbarrel_ids )
		self:SetupForbid( "wpn_fps_upg_ak_fg_tapco", underbarrel_ids )
		
		self:SetupForbid( "wpn_fps_ass_galil_fg_mar", underbarrel_ids )
		self:SetupForbid( "wpn_fps_ass_galil_fg_sar", underbarrel_ids )
		self:SetupForbid( "wpn_fps_ass_galil_fg_sniper", underbarrel_ids )
		self:SetupForbid( "wpn_fps_ass_galil_fg_standard", underbarrel_ids )
		
		self:SetupForbid( "wpn_fps_ass_ak5_fg_ak5a", underbarrel_ids )
		self:SetupForbid( "wpn_fps_ass_ak5_fg_fnc", underbarrel_ids )
		
		self:SetupForbid( "wpn_fps_lmg_rpk_fg_wood", underbarrel_ids )
		self:SetupForbid( "wpn_fps_upg_bp_lmg_lionbipod", underbarrel_ids )
		
		self:SetupForbid( "wpn_upg_saiga_fg_standard", underbarrel_ids )
		self:SetupForbid( "wpn_fps_sho_saiga_fg_holy", underbarrel_ids )
		
		self:SetupForbid( "wpn_fps_ass_g36_fg_ksk", underbarrel_ids )
		self:SetupForbid( "wpn_fps_upg_g36_fg_long", underbarrel_ids )
		
		self:SetupForbid( "wpn_fps_ass_fal_fg_wood", underbarrel_ids )
		self:SetupForbid( "wpn_fps_ass_fal_fg_03", underbarrel_ids )
		
		self:SetupForbid( "wpn_fps_ass_s552_fg_standard", underbarrel_ids )
		self:SetupForbid( "wpn_fps_ass_s552_fg_standard_green", underbarrel_ids )
		
		self:SetupForbid( "wpn_fps_ass_g3_fg_bipod", underbarrel_ids )
		self:SetupForbid( "wpn_fps_ass_g3_fg_retro", underbarrel_ids )
		self:SetupForbid( "wpn_fps_lmg_hk21_fg_long", underbarrel_ids )
		
		self:SetupForbid( "wpn_fps_ass_asval_b_standard", underbarrel_ids )
		
		self:SetupForbid( "wpn_fps_smg_akmsu_fg_standard", underbarrel_ids )
		
		self:SetupForbid( "wpn_fps_smg_olympic_fg_olympic", underbarrel_ids )
		self:SetupForbid( "wpn_fps_upg_smg_olympic_fg_lr300", underbarrel_ids )
		
		self:SetupForbid( "wpn_fps_smg_uzi_fg_standard", underbarrel_ids )
		
		if BeardLib.Utils:FindMod("Extra Attachments Compilation ±") then
			self:SetupForbid( "wpn_fps_upg_vg_verticalgrip", underbarrel_ids )
			self:SetupForbid( "wpn_fps_upg_vg_stubby", underbarrel_ids )
			self:SetupForbid( "wpn_fps_upg_vg_moe", underbarrel_ids )
			self:SetupForbid( "wpn_fps_upg_vg_tecci", underbarrel_ids )
			self:SetupForbid( "wpn_fps_upg_vg_foldable", underbarrel_ids )
			self:SetupForbid( "wpn_fps_upg_vg_grippod", underbarrel_ids )
			self:SetupForbid( "wpn_fps_upg_vg_afg", underbarrel_ids )
			self:SetupForbid( "wpn_fps_upg_vg_cobra", underbarrel_ids )
			table.insert(self.wpn_fps_ass_l85a2.uses_parts, underbarrel_ids)
		elseif BeardLib.Utils:FindMod("L86 LSW Kit") then
			table.insert(self.wpn_fps_ass_l85a2.uses_parts, underbarrel_ids)
			self:SetupForbid( "wpn_fps_ass_l85a2_fg_medium", underbarrel_ids )
			self:SetupForbid( "wpn_fps_ass_l85a2_fg_short", underbarrel_ids )
		end
		if BeardLib.Utils:FindMod("Underbarrel Weapons Pack") then
			self:SetupForbid( "wpn_fps_upg_gl_m203", underbarrel_ids )
			self:SetupForbid( "wpn_fps_upg_gl_m203_inc", underbarrel_ids )
			self:SetupForbid( "wpn_fps_ass_contraband_gl_m203_inc", underbarrel_ids )
			self:SetupForbid( "m203_secondary", underbarrel_ids )
		end
		self.parts[underbarrel_ids].override = {
			wpn_fps_upg_vg_ass_smg_verticalgrip = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"},
			wpn_fps_upg_vg_ass_smg_afg = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"},
			wpn_fps_ass_tecci_vg_standard = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"},
			wpn_fps_snp_tti_vg_standard = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"},
			wpn_fps_smg_hajk_vg_moe = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"},
			wpn_fps_upg_vg_ass_smg_stubby = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		}
		if BeardLib.Utils:FindMod("Gunshield") and not BeardLib.Utils:FindMod("Custom underbarrels for custom weapons") then
			self:SetupForbid( "wpn_fps_shield_v1", underbarrel_ids )
			self:SetupForbid( "wpn_fps_shield_ak", underbarrel_ids )
			self:SetupForbid( "wpn_fps_shield_aug", underbarrel_ids )
			self:SetupForbid( "wpn_fps_shield_dmr", underbarrel_ids )
			self:SetupForbid( "wpn_fps_shield_lr", underbarrel_ids )
			self:SetupForbid( "wpn_fps_shield_bullpup", underbarrel_ids )
			self:SetupForbid( "wpn_fps_shield_shotgun", underbarrel_ids )
			self:SetupForbid( "wpn_fps_shield_lmg", underbarrel_ids )
			self.parts[underbarrel_ids].override.wpn_fps_shield_v2 = {unit = "units/mods/weapons/wpn_fps_shield_pts/wpn_fps_shield_v3"}
			self.parts[underbarrel_ids].override.wpn_fps_shield_m4 = {unit = "units/mods/weapons/wpn_fps_shield_pts/wpn_fps_shield_v4"}
		end
		if BeardLib.Utils:FindMod("MP5K FG") then
			self:SetupForbid( "wpn_fps_smg_mp5_fg_stripped", underbarrel_ids )
		end
		if BeardLib.Utils:FindMod("Uzi VG-less") then
			self:SetupForbid( "wpn_fps_smg_uzi_fg_vgless", underbarrel_ids )
		end
		if BeardLib.Utils:FindMod("vertical_grip_attachment_pack") then
			self:SetupForbid( "wpn_fps_smg_uzi_fg_vgless", underbarrel_ids )
			self:SetupForbid( "wpn_fps_smg_mp5_fg_stripped", underbarrel_ids )
			self:SetupForbid( "wpn_fps_lmg_rpk_fg_akm", underbarrel_ids )
			self:SetupForbid( "wpn_upg_ak_fg_rpk_wood", underbarrel_ids )
			self:SetupForbid( "wpn_fps_smg_akmsu_fg_rpk", underbarrel_ids )
			self:SetupForbid( "wpn_fps_upg_fl_pis_surefire", underbarrel_ids )
		end
	
	end
	
	self:CheckOverride( "wpn", "wpn_fps_ass_aug" )
	self.wpn_fps_ass_aug.override.wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail_short"}
	self.wpn_fps_ass_aug.override.wpn_fps_ubs_six12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_six12_pts/wpn_fps_ubs_six12_rail_short"}
	
	self:CheckOverride( "wpn", "wpn_fps_smg_olympic" )
	self.wpn_fps_smg_olympic.override.wpn_fps_ubs_spas12 = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_sec/wpn_fps_ubs_spas12_sec"}
	self.wpn_fps_smg_olympic.override.wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail_short"}
	self.wpn_fps_smg_olympic.override.wpn_fps_ubs_six12 = {unit = "units/mods/weapons/wpn_fps_ubs_six12_sec/wpn_fps_ubs_six12_sec"}
	self.wpn_fps_smg_olympic.override.wpn_fps_ubs_six12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_six12_pts/wpn_fps_ubs_six12_rail_short"}
	
	self:CheckOverride( "wpn", "wpn_fps_smg_x_olympic" )
	self.wpn_fps_smg_x_olympic.override.wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail_short"}
	self.wpn_fps_smg_x_olympic.override.wpn_fps_ubs_six12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_six12_pts/wpn_fps_ubs_six12_rail_short"}
		
	self:CheckOverride( "wpn", "wpn_fps_smg_mp7" )
	self.wpn_fps_smg_mp7.override.wpn_fps_ubs_spas12 = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_sec/wpn_fps_ubs_spas12_sec"}
	self.wpn_fps_smg_mp7.override.wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail_short"}
	self.wpn_fps_smg_mp7.override.wpn_fps_ubs_six12 = {unit = "units/mods/weapons/wpn_fps_ubs_six12_sec/wpn_fps_ubs_six12_sec"}
	self.wpn_fps_smg_mp7.override.wpn_fps_ubs_six12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_six12_pts/wpn_fps_ubs_six12_rail_short"}
	
	self:CheckOverride( "wpn", "wpn_fps_smg_schakal" )
	self.wpn_fps_smg_schakal.override.wpn_fps_ubs_spas12 = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_sec/wpn_fps_ubs_spas12_sec"}
	self.wpn_fps_smg_schakal.override.wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail_short"}
	self.wpn_fps_smg_schakal.override.wpn_fps_ubs_six12 = {unit = "units/mods/weapons/wpn_fps_ubs_six12_sec/wpn_fps_ubs_six12_sec"}
	self.wpn_fps_smg_schakal.override.wpn_fps_ubs_six12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_six12_pts/wpn_fps_ubs_six12_rail_short"}
	
	self:CheckOverride( "wpn", "wpn_fps_smg_x_mp7" )
	self.wpn_fps_smg_x_mp7.override.wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail_short"}
	self.wpn_fps_smg_x_mp7.override.wpn_fps_ubs_six12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_six12_pts/wpn_fps_ubs_six12_rail_short"}
	
	self:CheckOverride( "wpn", "wpn_fps_smg_x_schakal" )
	self.wpn_fps_smg_x_schakal.override.wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail_short"}
	self.wpn_fps_smg_x_schakal.override.wpn_fps_ubs_six12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_six12_pts/wpn_fps_ubs_six12_rail_short"}
	
	self:CheckOverride( "wpn", "wpn_fps_smg_uzi" )
	self.wpn_fps_smg_uzi.override.wpn_fps_ubs_spas12 = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_sec/wpn_fps_ubs_spas12_sec"}
	self.wpn_fps_smg_uzi.override.wpn_fps_ubs_six12 = {unit = "units/mods/weapons/wpn_fps_ubs_six12_sec/wpn_fps_ubs_six12_sec"}
	
	self:CheckOverride( "wpn", "wpn_fps_smg_akmsu" )
	self.wpn_fps_smg_akmsu.override.wpn_fps_ubs_spas12 = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_sec/wpn_fps_ubs_spas12_sec"}
	self.wpn_fps_smg_akmsu.override.wpn_fps_ubs_six12 = {unit = "units/mods/weapons/wpn_fps_ubs_six12_sec/wpn_fps_ubs_six12_sec"}
	
	self:CheckOverride( "wpn", "wpn_fps_sho_rota" )
	self.wpn_fps_sho_rota.override.wpn_fps_ubs_spas12 = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_sec/wpn_fps_ubs_spas12_sec"}
	self.wpn_fps_sho_rota.override.wpn_fps_ubs_six12 = {unit = "units/mods/weapons/wpn_fps_ubs_six12_sec/wpn_fps_ubs_six12_sec"}
	
	for i, underbarrel_ids in ipairs(ubs_list) do
		self.parts[underbarrel_ids].weapon_hold_override = self.parts[underbarrel_ids].weapon_hold_override or {}
		
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_m14 		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_hajk		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_m4		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_m32		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_flamethrower_mk2	= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_akm		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_ak74		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_akm_gold	= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_akmsu		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_desertfox	= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_amcar 	= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_schakal 	= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_galil		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_ak12		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_ak5		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_rpk		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_saiga		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_m16		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_g36		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_l85a2		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_fal		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_uzi		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_mp7		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_corgi		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_vhs		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_olympic	= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_scar		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_s552		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_g3		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_rota 		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_aug 		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_asval 	= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_tecci 	= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_tti 		= "contraband" 
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_ubs_spas12 = "contraband"  
		self.parts[underbarrel_ids].weapon_hold_override.bm_w_ubs_six12 = "contraband" 
			
		self.parts[underbarrel_ids].weapon_stance_override = self.parts[underbarrel_ids].weapon_stance_override or {}
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_m14 		= "m14_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_hajk 		= "hajk_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_m4 			= "m4_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_m32 		= "m4_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_flamethrower_mk2 	= "m4_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_akm			= "akmsu_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_ak74		= "akmsu_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_akm_gold	= "akmsu_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_akmsu 		= "akmsu_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_desertfox 	= "dfox_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_amcar 		= "colt733_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_schakal 	= "ump_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_galil		= "galil_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_ak12		= "ak12_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_ak5			= "ak5_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_rpk 		= "akmsu_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_saiga 		= "akmsu_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_m16 		= "colt733_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_g36 		= "m4_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_l85a2 		= "l85a2_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_fal 		= "fal_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_uzi 		= "uzi_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_mp7 		= "uzi_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_corgi 		= "f2000_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_vhs			= "l85a2_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_olympic 	= "colt733_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_scar 		= "scar_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_s552 		= "sg552_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_g3 			= "g3_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_rota 		= "six12_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_aug			= "aug_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_asval		= "asval_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_tecci 		= "hk416c_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_tti 		= "tti_gl_mp" 
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_ubs_spas12 	= "ubs_gl_mp"  
		self.parts[underbarrel_ids].weapon_stance_override.bm_w_ubs_six12 	= "ubs_gl_mp" 
			
		self.parts[underbarrel_ids].weapon_reload_override = self.parts[underbarrel_ids].weapon_reload_override or {}	
		self.parts[underbarrel_ids].weapon_reload_override.bm_w_contraband_m203 = "contraband" 
	end
	
end )